#!/bin/bash

echo "" > historial.txt                 #si no existe historial.txt se crea, de lo contrario se limpia
niscat passwd.org_dir > dir.txt         #se guardan los datos de los usuarios almacenados por aragorn
while [ true ]                          #loop que permite que el programa itere continuamente hasta que se le haga un stop (basicamente con ctrl-z)
        do
        who >conectados.txt             #se crea el archivo conectados con los datos resultantes del comando who
        cat conectados.txt | (
        while read line;                #se lee linea por linea el archivo conectados.txt, para poder analizar cada una de las conexiones entregadas por who
                do
                username=`echo $line | cut -d " " -f 1`         #se guarda el usuario encontrado (en dicha linea del archivo)
                user=`grep $username dir.txt | cut -d ":" -f 1`
                realname=`grep $username dir.txt | cut -d ":" -f 5`             #se formatea el nombre completo del usuario
                dns=`echo $line | cut -d ')' -f 1 - | cut -d '(' -f 2-`;        #se obtiene el dns de la conexion del usuario a aragorn (en algunos caso este sera directamente la ip)
                date=`echo $line | cut -d "(" -f 1 | cut -d " " -f 3-`          #se almacena la fecha de la conexion
                if [ "`dig +short $dns`" = "" ]; then                           #se obtiene la direccion ip de la conexion
                        ip=$dns
                else
                        ip=`dig +short $dns`
                fi
                subred=`ipcalc -bn $ip | grep  Network | cut -d " " -f 4`       #se calcula la subred de la conexion
                subred_ent=`ipcalc -bn $1 | grep  Network | cut -d " " -f 4`
                aux=`grep "$date $user $realname $ip" historial.txt`            #se revisa si la conexion ya fue entregada con anterioridad por el script
                if [ "$subred" = "$subred_ent" ]; then                          #se verifica si el usuario pertenece a la subred que se desea estudiar
                        if [ "$aux" = "" ]; then                                #se muestra por pantalla solo las nuevas conexiones, evitando mostrar informacion redundante
                                echo "$date $user $realname $ip"
                                echo "$date $user $realname $ip">>historial.txt #se almacena la nueva conexion para tener un registro y no volver a mostrarla en el futuro
                        fi
                fi
        done;)
        sleep 5 #se esperan 5 segundos antes de la siguiente iteracion para no forzar tanto la cpu
done
